//********************************************************************
//*-------------------------------------------------------------------
//* Sample Source
//*
//* 5724-A18
//*
//* (c) Copyright IBM Corp. 2000, 2002
//*
//* The source code for this program is not published or otherwise
//* divested of its trade secrets, irrespective of what has been
//* deposited with the US Copyright Office.
//*-------------------------------------------------------------------
//*
////////////////////////////////////////////////////////////////////////////////

import com.ibm.commerce.usermanagement.commands.*;

import java.util.*;
import com.ibm.commerce.ras.*;
import com.ibm.commerce.exception.*;
import com.ibm.commerce.server.*;
import com.ibm.commerce.common.objects.*; 
import com.ibm.commerce.command.*;
import com.ibm.commerce.server.*;
import com.ibm.commerce.datatype.*;
import com.ibm.commerce.user.objects.*;
import com.ibm.commerce.member.helpers.*;
/**
 * The implementation class for ProcessProfileTypeCmd.
 */
public class ProcessProfileTypeCmdImpl extends TaskCommandImpl implements ProcessProfileTypeCmd
{
	public static final String COPYRIGHT = com.ibm.commerce.copyright.IBMCopyright.SHORT_COPYRIGHT;
	public final static String CLASSNAME = "com.ibm.commerce.usermanagement.commands.ProcessProfileTypeCmdImpl";
	protected TypedProperty requestProperties = null;

public String getProfileType()
{
	return requestProperties.getString(ECUserConstants.EC_USER_PROFILETYPE, null);
}
public TypedProperty getRequestProperties()
{
	return requestProperties;
}
public void performExecute() throws ECException
{
	final String METHODNAME = "performExecute";
	TypedProperty hshNVPs = new TypedProperty();	
	ECTrace.entry(ECTraceIdentifiers.COMPONENT_USER, CLASSNAME, METHODNAME);
	if (requestProperties == null)
	{
		ECTrace.trace(ECTraceIdentifiers.COMPONENT_USER, CLASSNAME, METHODNAME, 
						"requestProperties is not set");	
		return;
	}

	String strProfileType = requestProperties.getString(ECUserConstants.EC_USER_PROFILETYPE, null);	
	if (strProfileType == null)
	{
		String strParentMemberId = requestProperties.getString(ECUserConstants.EC_PARENTMEMBERID, null);
		// If ProfileType is null and parentMemberId is null or default organization, by default, it is a customer.
		if (strParentMemberId == null || strParentMemberId.equals(ECMemberConstants.EC_DB_DEFAULT_ORGANIZATION_ID))
		{
			strProfileType = ECUserConstants.EC_USER_PROFILE_CUSTOMER;
		}
		else
		{
		// If ProfileType is null and parentMemberId is not default organization, by default, it is a business user.
			strProfileType = ECUserConstants.EC_USER_PROFILE_BUSINESS;
		}
		requestProperties.put(ECUserConstants.EC_USER_PROFILETYPE, strProfileType);
	}
	// Make sure the ProfileType is not null and is either C or B	
	else if (!strProfileType.equals(ECUserConstants.EC_USER_PROFILE_CUSTOMER) &&
			!strProfileType.equals(ECUserConstants.EC_USER_PROFILE_BUSINESS))
	{
		hshNVPs.put(ECConstants.EC_ERROR_CODE, ECUserConstants.EC_USER_ERR_BAD_PROFILETYPE);
		throw new ECApplicationException(ECMessage._ERR_CMD_INVALID_PARAM, CLASSNAME, METHODNAME,
										 ECMessageHelper.generateMsgParms(ECUserConstants.EC_USER_PROFILETYPE),
										 ECUserConstants.EC_CMD_USERREGISTRATION_ERR_VIEWNAME, hshNVPs);			
	}
		
	ECTrace.exit(ECTraceIdentifiers.COMPONENT_USER, CLASSNAME, METHODNAME);	
}
public void setRequestProperties(TypedProperty aRequestProperties)
{
	requestProperties = aRequestProperties;
}
}
